<?php
namespace App\Controllers\Clientes;


use App\Controllers\BaseResourceController;
use App\Models\Collection;

use App\Entities\Clientes\ClientePlantillaPreciosEntity;

use App\Models\Clientes\ClientePlantillaPreciosModel;


class Clienteplantillaprecios extends \App\Controllers\BaseResourceController
{

    protected $modelName = ClientePlantillaPreciosModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Cliente plantilla precios';
    protected static $singularObjectNameCc = 'clienteplantillaprecios';
    protected static $pluralObjectName = 'Clientes plantilla precios';
    protected static $pluralObjectNameCc = 'clientesplantillaprecios';

    protected static $controllerSlug = 'clienteplantillaprecios';

    protected static $viewPath = 'themes/vuexy/form/clientes/plantillaprecios/';

    protected $indexRoute = 'clienteplantillapreciosList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('ClientesPrecios.plantillaPrecios_module');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        $this->viewData = ['usingServerSideDataTable' => true]; // JJO

        // Breadcrumbs (IMN)
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_clientes"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_plantillas_tarifas_clientes"), 'route' => route_to("clienteplantillapreciosList"), 'active' => true]
        ];

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('ClientePrecios.plantillaPrecios_module')]),
            'clientePlantillaPreciosEntity' => new ClientePlantillaPreciosEntity(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewClienteplantillapreciosList', $viewData);
    }


    // Este metodo aqui se usa para poner el is_deleted a 1 cuando se borra una
    // plantilla desde la lista
    public function update($requestedId = null)
    {

        if ($requestedId == null):
            return;
        endif;
        $model = model('App\Models\Clientes\ClientePlantillaPreciosLineasModel');
        $model->delete_values($requestedId);

        $newTokenHash = csrf_hash();
        $csrfTokenName = csrf_token();
        $data = [
            $csrfTokenName => $newTokenHash
        ];

        return $this->respond($data);

    }


    public function add()
    {



        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $cliente_id = $postData['cliente_id'] ?? -1;
            $from_client_data = $postData['from_client_data'] ?? 0;

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_created_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                if ($from_client_data == 1) {
                    $thenRedirect = false;
                } else {
                    $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
                }
            endif;
            if ($noException && $successfulResult):

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($cliente_id != -1) {
                    $modelLineas = model('App\Models\Clientes\ClientePlantillaPreciosLineasModel');
                    $modelLineas->copy_from_cliente($cliente_id, $id);
                    $modelClientePrecios = model('App\Models\Clientes\ClientePreciosModel');
                    $modelClientePrecios->set_plantilla_id($cliente_id, $id);
                    return $this->respond(['status' => 'success', 'id' => $id]);
                } else {
                    if ($thenRedirect):
                        if (!empty($this->indexRoute)):
                            //return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                            return redirect()->to(site_url('/clienteplantillaprecios/edit/' . $id))->with('message', $message);
                        else:
                            return $this->redirect2listView('sweet-success', $message);
                        endif;
                    else:
                        $this->session->setFlashData('sweet-success', $message);
                    endif;
                }

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['clienteplantillapreciosEntity'] = isset($sanitizedData) ? new ClientePlantillaPreciosEntity($sanitizedData) : new ClientePlantillaPreciosEntity();
        $this->viewData['formAction'] = route_to('createClienteplantillaprecios');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('ClientePrecios.plantillaPrecios_name') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {


        if ($requestedId == null):
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $clientePlantillaPreciosEntity = $this->model->find($id);

        if ($clientePlantillaPreciosEntity == false):
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Clientes.cliente')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;



        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            $sanitizedData['user_updated_id'] = auth()->user()->id;

            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Clientes.cliente'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $clientePlantillaPreciosEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult):
                $id = $clientePlantillaPreciosEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        //var_dump($clientePlantillaPreciosEntity); dd();

        $this->viewData['clienteplantillapreciosEntity'] = $clientePlantillaPreciosEntity;

        $this->viewData['formAction'] = route_to('updateClienteplantillaprecios', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('Clientes.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function updatePlantillaEnCliente(){

        if ($this->request->isAJAX()) {

            $reqData = $this->request->getPost();
            $plantilla_id = $reqData['plantilla_id'] ?? -1;

            $model = model('App\Models\Clientes\ClientePreciosModel');
            $model->update_plantilla_id($plantilla_id);
            

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $searchValues = get_filter_datatables_columns($reqData);
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $order = ClientePlantillaPreciosModel::SORTABLE[$requestedOrder > 0 ? $requestedOrder : 0];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $resourceData = $this->model->getResource($searchValues)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();
            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($searchValues)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {

        if ($this->request->isAJAX()) {
            $query = $this->model->builder()->select(
                [
                    "id",
                    "nombre as name"
                ]
            )->where("deleted_at", null);
            if ($this->request->getGet("q")) {
                $query->groupStart()
                    ->orLike("cliente_plantilla_precios.nombre", $this->request->getGet("q"))
                    ->groupEnd();
            }

            $items = $query->get()->getResultObject();
            // add a custom item at the beginning
            $customItem = new \stdClass;
            $customItem->id = 0;
            $customItem->name = "Personalizado";
            array_unshift($items, $customItem);

            return $this->response->setJSON($items);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }

    }

}
